/*
 ################################################
 # part of the linuxCNC-raspberry/arduino-project
 # (c) by Ralf Burger 2019
 # Licence GPL
 # http://erste.de/ethraw/
 ################################################
*/

void usage(void)
{
	fprintf(stderr, "usage:\n");
	help();				// display compile/install-help
#ifdef ISDISPLAY
	 fprintf(stderr, "\t-d debuglevel (BITMASK) \n");
	 fprintf(stderr, "\t-n 1st char of display-line names (default \"XYZA\") \n");
	return;
#endif
	fprintf(stderr, "\toptions -i network-device -s aa:bb:cc:dd:ee:ff:gg (send to mac-addr) \n"
	                "\t-r hh:ii:jj:kk:ll:mm  (reveive: my own mac-addr) -v\n"
	                "\t-u 192.168.0.242      (send to IP-address as UDP) -v\n"
	                "\t-k int-number  (shmem-key. default 12399  ) \n");
	
	fprintf(stderr, "\t-d debuglevel (BITMASK)  -t testmode (bitmask)\n");
#ifdef ISRASPI 
	fprintf(stderr, "\t-q quad-table-entry        \n") ;
#endif
	fprintf(stderr, "\t        \n");

	fprintf(stderr, "\t      debug  (bitmask)\n");
	fprintf(stderr, "\t           1  -> fixme,    2  -> fixme,    4  -> fixme\n");
	fprintf(stderr, "\t        %4d -> in packets, %4d -> machting header, %4d -> listening\n",deb_recpkt,deb_match,deb_listen);
	fprintf(stderr, "\t        %4d -> print snd UDP \n",deb_sudp);
	fprintf(stderr, "\t        %4d -> print snd RAWs\n",deb_sraw);
	fprintf(stderr, "\t        %4d -> print set port commands\n",deb_port);
        fprintf(stderr, "\t        %4d -> print quad-debug \n",deb_quad);
	fprintf(stderr, "\t        \n");



	fprintf(stderr, "\t     testmode (bitmask)\n");
	fprintf(stderr, "\t	   1 -> do not send\n");
	fprintf(stderr, "\t	   2 -> do not receive\n");
	fprintf(stderr, "\t	   4 -> endless send-receive-loopback\n");
	fprintf(stderr, "\t	%4d -> endless flood sending\n",testmode_sflood);
	fprintf(stderr, "\t	%4d -> no lost-packet-check\n",testmode_nolostpk);
	fprintf(stderr, "\t	%4d -> port-test\n",testmode_porttest);
	fprintf(stderr, "\t	%4d -> timebase-test\n",testmode_timebase);


	
	fprintf(stderr, "\t        \n");

	fprintf(stderr, "\nDescription:\n");
	fprintf(stderr, "\tThis utility is part of the linuxcnc-rasPI project\n"
			"\thttp://erste.de/rasPiCat.html\n\n"
			"give MAC (r) address and name of local (-d) and MAC of corresponding device (-s)."
			"\n");

	exit(EXIT_FAILURE);
}

unsigned char smac[ETH_ALEN];   //send to MAC
unsigned char rmac[ETH_ALEN];   //receive for MAC

int getCLopt(int argc, char **args)
{
			int qt[3];

	int sock, err = 0, opt;int q;
	bool has_mac = false, has_dev = false, verbose = false,num=10;
	bool has_dmac=false,has_rmac=false;
#ifdef ISDISPLAY
	while ((opt = getopt(argc, args, "hi:n:d:")) != -EXIT_FAILURE) {
		switch (opt) {

                case 'h':
			usage();
			exit(-1);
			err=-1;
                        break;

                case 'd':
                        debug = atoi( optarg );
                        printf("running debung level:%4d\n",debug);
                        break;

		case 'n':
			sscanf(optarg, "%s", dname);
			printf("display-names are:%s\n",dname);
			break;

		case 'i':
			return 1;
			break;

                default:
                        err = -1;
                        break;
                }

                if (err)
			return EXIT_FAILURE;
                        break;
        }
	return;
#endif

#ifdef ISRASPI 
	while ((opt = getopt(argc, args, "r:s:i:v:d:t:q:")) != -EXIT_FAILURE) {
#else
	while ((opt = getopt(argc, args, "u:k:r:s:i:v:d:t:")) != -EXIT_FAILURE) {
#endif
		switch (opt) {
		case 'i':
			has_dev = true;
			strncpy(dev_name, optarg, IFNAMSIZ);
	        fprintf(stdout, "Opening interface [%s].\n", dev_name);
			break;


		case 'u':
			has_rmac = true;
			int i1,i2,i3,i4;
			err = sscanf(optarg, "%i.%i.%i.%i",&i1,&i2,&i3,&i4) != 4;
			toUDP[0]=i1;toUDP[1]=i2;toUDP[2]=i3;toUDP[3]=i4;
         		fprintf(stdout, "send UDP to     :%i.%i.%i.%i\n", toUDP[0],toUDP[1],toUDP[2],toUDP[3]);
			break;


		case 'r':
			has_rmac = true;
			err = sscanf(optarg, MAC_STR, MAC_ARG(rmac)) != 6;
         		fprintf(stdout, "recieve for Mac-address ["MAC_STR"].\n", MAC_ARG2(rmac));

			break;
		case 'k':
			shkey = atoi( optarg );
         		fprintf(stdout, "use shmemkey %5i\n", shkey);
			break;


		case 's':
			has_dmac = true;
			err = sscanf(optarg, MAC_STR, MAC_ARG(smac)) != 6;
         		fprintf(stdout, "send to  Mac-address ["MAC_STR"].\n", MAC_ARG2(smac));
			break;
		case 'v':
			verbose = true;
			break;

		case 'd':
			debug = atoi( optarg );
			printf("running debung level:%4d\n",debug);
			break;

		case 't':
			testmode = atoi( optarg );
			printf("running in testmode:%4d\n",testmode);
			break;

#ifdef ISRASPI 
		case 'q':	
			err = sscanf(optarg, "[%d][%d]=[%d/%d]", &qt[0],&qt[1],&qt[2],&qt[3]);
			printf("q=[%d][%d][0,1]={%d,%d} err: %d\n",qt[0],qt[1],qt[2],qt[3],err);
			P_QUADSTEP_array[qt[0]][qt[1]][0]=qt[2];
			P_QUADSTEP_array[qt[0]][qt[1]][1]=qt[3];
			err=0;
			break;
#endif


		default:
			err = -1;
			break;
		}

		if (err)
			break;
	}

	if (!has_dmac || !has_rmac || !has_dev || err)
		usage();



	if (err < 0)
		return EXIT_FAILURE;
	return 0;
}

