/*
 ################################################
 # part of the linuxCNC-raspberry/arduino-project
 # (c) by Ralf Burger 2019
 # Licence GPL
 # http://erste.de/ethraw/
 ################################################
*/

char* toBits(size_t const size, void const * const ptr)
{
    unsigned char *b = (unsigned char*) ptr;
    unsigned char byte;
    int i, j;
	char str[12]={0x30,0};
	static char res[64];
	res[0]=0;
    for (i=size-1;i>=0;i--)
    {
        for (j=7;j>=0;j--)
        {
	 if ((b[i] >> j) & 1) str[0]='X'; else str[0]=' ';
//            sprintf(str,"%u", byte);
	strcat(res,str);
        }
    }
	return res;
}

void print_stamp(){
        struct tm *newtime;
        time_t long_time;
        time( &long_time );
        newtime = localtime( &long_time );
        printf("%2d:%2d:%2d - ", newtime->tm_hour, newtime->tm_min, newtime->tm_sec);
}
static double lasttime,lasttdiff;

struct timeval get_timestamp(){
        struct timeval timer_start;
        gettimeofday(&timer_start, NULL);
//      printf("time: %lu.%lu\n",timer_start.tv_sec,timer_start.tv_usec);
        return timer_start;
}


/**
 * Returns the current time in microseconds.
 */
long getMicrotime(){
        struct timeval currentTime;
        gettimeofday(&currentTime, NULL);
        return currentTime.tv_sec * (int)1e6 + currentTime.tv_usec;
}


void print_header(int numbytes)          {
	printf("\nEthernet Header\n");
	printf("\t|-incomming source address     : "MAC_STR"\n",
	recbufs->sh[0],recbufs->sh[1],recbufs->sh[2],
	recbufs->sh[3],recbufs->sh[4],recbufs->sh[5]);
	printf("\t|-expected source address      : "MAC_STR"\n",
	smac[0],smac[1],smac[2],smac[3],smac[4],smac[5]);
	printf("\t|-incomming destination address: "MAC_STR"\n",
	recbufs->dh[0],recbufs->dh[1],recbufs->dh[2],
	recbufs->dh[3],recbufs->dh[4],recbufs->dh[5]);
	printf("\t|-expexted  destination address: "MAC_STR"\n", 
	rmac[0], rmac[1], rmac[2], rmac[3], rmac[4], rmac[5] );
	printf("\t|-type:  %.2X %.2x    payload      : "MAC_STR" size: %d\n",
	recbufs->tp[0],recbufs->tp[1],
	recbufs->outval[0],recbufs->outval[1],recbufs->outval[2],recbufs->outval[3],
	recbufs->outval[4],recbufs->outval[5], numbytes);
	printf("\t|-validoutval                  : "MAC_STR" (from sender) sndrawcount: %4x\n",
	recbufs->validoutval[0],recbufs->validoutval[1],recbufs->validoutval[2],recbufs->validoutval[3],
	recbufs->validoutval[4],recbufs->validoutval[5], recbufs->sndrawcount);

	printf("\t|-validinval                   : "MAC_STR" recrawcount: %4x\n",
	recbufs->validinval[0],recbufs->validinval[1],recbufs->validinval[2],recbufs->validinval[3],
	recbufs->validinval[4],recbufs->validinval[5], recbufs->recrawcount);


	printf("\t|-validfloat  key(%02i)          : %4.4f\n",recbufs->validfloatkey,recbufs->validfloatval);
}


void    print_sheader(int numbytes) {
        printf("\nEthernet send header\n");
        printf("\t|-send to destination address  : "MAC_STR"\n",
        recbufs->ssh[0],recbufs->ssh[1],recbufs->ssh[2],
        recbufs->ssh[3],recbufs->ssh[4],recbufs->ssh[5]);
        printf("\t|-send from source address     : "MAC_STR"\n",
        recbufs->sdh[0],recbufs->sdh[1],recbufs->sdh[2],
        recbufs->sdh[3],recbufs->sdh[4],recbufs->sdh[5]);
        printf("\t|-type:  %.2X %.2x    payload      : "MAC_STR" size: %d\n",
        recbufs->tp[0],recbufs->tp[1],
        recbufs->outval[0],recbufs->outval[1],recbufs->outval[2],recbufs->outval[3],
        recbufs->outval[4],recbufs->outval[5], numbytes);
        printf("\t|-validoutval                  : "MAC_STR" (from sender) sndrawcount: %4x\n",
        recbufs->validoutval[0],recbufs->validoutval[1],recbufs->validoutval[2],recbufs->validoutval[3],
        recbufs->validoutval[4],recbufs->validoutval[5], recbufs->sndrawcount);

        printf("\t|-validinval                   : "MAC_STR" recrawcount: %4x\n",
        recbufs->validinval[0],recbufs->validinval[1],recbufs->validinval[2],recbufs->validinval[3],
        recbufs->validinval[4],recbufs->validinval[5], recbufs->recrawcount);


        printf("\t|-validfloat  key(%02i)          : %4.4f\n",recbufs->validfloatkey,recbufs->validfloatval);
}






int getch(void) {
    int character;
    struct termios orig_term_attr;
    struct termios new_term_attr;

    /* set the terminal to raw mode */
    tcgetattr(fileno(stdin), &orig_term_attr);
    memcpy(&new_term_attr, &orig_term_attr, sizeof(struct termios));
    new_term_attr.c_lflag &= ~(ECHO|ICANON);
    new_term_attr.c_cc[VTIME] = 0;
    new_term_attr.c_cc[VMIN] = 0;
    tcsetattr(fileno(stdin), TCSANOW, &new_term_attr);

    /* read a character from the stdin stream without blocking */
    /*   returns EOF (-1) if no character is available */
    character = fgetc(stdin);

    /* restore the original terminal attributes */
    tcsetattr(fileno(stdin), TCSANOW, &orig_term_attr);

    return character;
}

#ifdef THREADED
void *thread_func(void *data);
int init_thread(){
        struct sched_param param;
        pthread_attr_t attr;
        pthread_t thread;
        int ret;

        /* Lock memory */
        if(mlockall(MCL_CURRENT|MCL_FUTURE) == -1) {
                printf("mlockall failed: %m\n");
               return(-2);
        }

        /* Initialize pthread attributes (default values) */
        ret = pthread_attr_init(&attr);
        if (ret) {
                printf("init pthread attributes failed\n");
                return ret;
        }

        /* Set a specific stack size  */
        ret = pthread_attr_setstacksize(&attr, PTHREAD_STACK_MIN);
        if (ret) {
            printf("pthread setstacksize failed\n");
                return ret;
        }

        /* Set scheduler policy and priority of pthread */
        ret = pthread_attr_setschedpolicy(&attr, SCHED_FIFO);
        if (ret) {
                printf("pthread setschedpolicy failed\n");
                return ret;
        }
        param.sched_priority = 80;
        ret = pthread_attr_setschedparam(&attr, &param);
        if (ret) {
                printf("pthread setschedparam failed\n");
                return ret;
        }
        /* Use scheduling parameters of attr */
        ret = pthread_attr_setinheritsched(&attr, PTHREAD_EXPLICIT_SCHED);
        if (ret) {
                printf("pthread setinheritsched failed\n");
                return ret;
        }

        /* Create a pthread with specified attributes */
        ret = pthread_create(&thread, &attr, thread_func, NULL);
        if (ret<0) {
                perror("pthread_create");
                printf("create pthread failed: %d\n",ret);
        	return ret;
        }
        return 0;
        }
#endif
static int s;
static	int PORT=666;
	struct sockaddr_in si_me, si_other;
	
static 	int   slen = sizeof(si_other) , recv_len;
static	char buf[BUFSIZ];


int rec_udp(){  
                int recv_len; 
                //try to receive some data, this is a NON blocking call 
#ifdef ISDISPLAY
              recv_len = recvfrom(udprsockfd, recbufs->validoutval, BUFSIZ  , 0, (struct sockaddr *) &si_other, &slen); 
#else
                recv_len = recvfrom(udprsockfd, buf, BUFSIZ, 0, (struct sockaddr *) &si_other, &slen); 
#endif
                 if (debug) if (recv_len>0){     
                        //print details of the client/peer and the data received 
                        printf("Received packet from %s:%d len:%u\n", 
				inet_ntoa(si_other.sin_addr), ntohs(si_other.sin_port),recv_len); 
                        int f=0; 
                        } 
 
        return  recv_len;                
} 




static long lastUDPtime=0;
static float lastfloat[5];
int init_udp_snd(void){
         struct sockaddr_in si_other;
         int i, slen=sizeof(si_other);
         char buf[100];
	 int s;
        //create a UDP socket
        if ((udpssockfd=socket(AF_INET, SOCK_DGRAM, IPPROTO_UDP)) == -1)
        {
                perror("socket");
		return -1;
        }
        memset((char *) &si_other, 0, sizeof(si_other));
        si_other.sin_family = AF_INET;
        si_other.sin_port = htons(PORT);
	memcpy(&si_other.sin_addr,&toUDP,4);
        if( bind(udpssockfd , (struct sockaddr*)&si_me, sizeof(si_me) ) == -1)
        {
                perror("bind");	
		return -1;
        }
        return udpssockfd;
}

int init_udp_rec(){
        //create a UDP socket
        if ((udprsockfd=socket(AF_INET, SOCK_DGRAM, IPPROTO_UDP)) == -1)
        {
                perror("socket");
        }
        // zero out the structure
        memset((char *) &si_me, 0, sizeof(si_me));

        si_me.sin_family = AF_INET;
        si_me.sin_port = htons(PORT);
        si_me.sin_addr.s_addr = htonl(INADDR_ANY);

        //bind socket to port
        if( bind(udprsockfd , (struct sockaddr*)&si_me, sizeof(si_me) ) == -1)
        {
                perror("bind");
        }

        struct timeval read_timeout;
        read_timeout.tv_sec = 0;
        read_timeout.tv_usec = 10;
        setsockopt(udprsockfd, SOL_SOCKET, SO_RCVTIMEO, &read_timeout, sizeof read_timeout);
        return s;
}


int close_udp_snd(){
        close(udpssockfd);
        return 0;
        exit(1);
}



//int udp_send_packet(void)
int snd_udp(void){
	if (recbufs->validfloatval==lastfloat[recbufs->validfloatkey]) return 0;
	lastfloat[recbufs->validfloatkey]=recbufs->validfloatval;
	 if (debug & deb_sudp ) { 
		printf("Sending UDP socket: %i port %i floatkey:%i validfloatval:%10.3f lastfloatval:%10.3f\n", 
		udpssockfd,PORT,recbufs->validfloatkey,recbufs->validfloatval,lastfloat[recbufs->validfloatkey]);
      	}


	if (getMicrotime()<(lastUDPtime+10000)) return 0;
	lastUDPtime=getMicrotime();
        memset((char *) &si_other, 0, sizeof(si_other));
        si_other.sin_family = AF_INET;
        si_other.sin_port = htons(PORT);
        memcpy(&si_other.sin_addr,&toUDP,4);
          if (sendto(udpssockfd, recbufs->validoutval, 100, 0, (struct sockaddr*)&si_other, slen)==-1)
            perror("sendto()");
        return 0;
}

void move_buf_to_valid(){
        int f;
        for (f=0; f<5; f++){
                recbufs->validoutval[f]=recbufs->outval[f];
                recbufs->validinval[f]=recbufs->inval[f];
        }
	recbufs->validfloatval=recbufs->floatval;
	recbufs->validfloatkey=recbufs->floatkey;
}

void move_valid_to_buf(){
        int f;
        for (f=0; f<5; f++){
                recbufs->outval[f]=recbufs->validoutval[f];
//                recbufs->inval[f]=recbufs->validinval[f];
        }
	recbufs->floatval=recbufs->validfloatval;
	recbufs->floatkey=recbufs->validfloatkey;
}


int rec_raw(){  // raw-eth-receive
                // we hatve to check: is this really a packet for us?           
        bool isForMe=false;  // is it a packet for me?
        numbytes = recvfrom(rawrsockfd, recbufs, BUF_SIZ, 0, NULL, NULL);
        if (numbytes==-1) return 0;
        if (numbytes!=62) return 0;
        if ((debug & deb_recpkt )>0) print_header(numbytes);
        if (debug & deb_recpkt) printf("listener: got packet %lu bytes\n", numbytes);

        /* Check the packet is for me */
        if (            recbufs->dh[0] == rmac[0]   &&
                        recbufs->dh[1] == rmac[1]   &&
                        recbufs->dh[2] == rmac[2]   &&
                        recbufs->dh[3] == rmac[3]   &&
                        recbufs->dh[4] == rmac[4]   &&
                        recbufs->dh[5] == rmac[5]  ) {
                if (DEBUG & DEB_CORRECT_MAC)printf("Correct destination MAC address  %x:%x:%x:%x:%x:%x\n",
                                                recbufs->dh[0],
                                                recbufs->dh[1],
                                                recbufs->dh[2],
                                                recbufs->dh[3],
                                                recbufs->dh[4],
                                                recbufs->dh[5]);
                                                isForMe=true;
                                        if (DEBUG && DEB_PACKET) print_header(numbytes);
                } else {
                if (DEBUG & DEB_WRONG_MAC) printf("Wrong destination MAC: %x:%x:%x:%x:%x:%x\n",
                                                recbufs->dh[0],
                                                recbufs->dh[1],
                                                recbufs->dh[2],
                                                recbufs->dh[3],
                                                recbufs->dh[4],
                                                recbufs->dh[5]);
                isForMe=false;
                return 0;
        }
	move_buf_to_valid(); /////////////////////// FIXME!!!!!!!!!!!!!!!!!!!!!
        return 1;
}

int init_raw_rec_socket(char devn[]){
        printf("init_rec_socket. DEV:[%s]\n",devn);
        rawrsockfd=socket( PF_PACKET, SOCK_RAW, htons( ETH_P_ALL ) );
        if (rawrsockfd<0) {
                perror("setsockopt1");
                close(rawrsockfd);
                return(EXIT_FAILURE);
        }
        strncpy(ifopts.ifr_name, devn, IFNAMSIZ-1);
        ioctl(rawrsockfd, SIOCGIFFLAGS, &ifopts);
        ifopts.ifr_flags |= IFF_PROMISC;
        ioctl(rawrsockfd, SIOCSIFFLAGS, &ifopts);
        
        /* Bind to device */
        if (setsockopt(rawrsockfd, SOL_SOCKET, SO_BINDTODEVICE, dev_name, IFNAMSIZ-1) == -1) {
                perror("SO_BINDTODEVICE");
                close(rawrsockfd);
                return(EXIT_FAILURE);
        }

        int flags = fcntl(rawrsockfd, F_GETFL);
        flags |= O_NONBLOCK;
        fcntl(rawrsockfd, F_SETFL, flags);
        memset(&if_ip, 0, sizeof(struct ifreq));

        if ((rawrsockfd = socket( PF_PACKET, SOCK_RAW, htons( ETH_P_ALL))) == -1) {
                perror("non blocking listener: socket");
		return(EXIT_FAILURE);
        }

	flags = fcntl(rawrsockfd, F_GETFL);
	flags |= O_NONBLOCK;
	fcntl(rawrsockfd, F_SETFL, flags);
        return 0;


}

int init_raw_snd_socket(char devn[]){
   rawssockfd = socket( PF_PACKET, SOCK_RAW, htons( ETH_P_ALL ) );

     /* bind to interface */
    struct ifreq req;
    printf("sending to MAC: "MAC_STR" dev: %s \n",
	 smac[0], smac[1], smac[2], smac[3], smac[4], smac[5],devn);
    memset( &req, 0, sizeof( req ) );

    strcpy( (char*)req.ifr_name, devn );

    if ( ioctl( rawssockfd, SIOCGIFINDEX, &req ) < 0 )
    {
        perror( "init: ioctl" );
        close( rawssockfd);
        return -1;
    }

    struct sockaddr_ll addr;
    memset( &addr, 0, sizeof( addr ) );
    addr.sll_family   = PF_PACKET;
    addr.sll_protocol = 0;
    addr.sll_ifindex  = req.ifr_ifindex;

    if ( bind( rawssockfd, (const struct sockaddr*)&addr, sizeof( addr ) ) < 0 )
    {
        perror( "init: bind fails" );
        close( rawssockfd );
        return -1 ;
    }

    if ( ioctl( rawssockfd, SIOCGIFHWADDR, &req ) < 0 )
    {
        perror( "init: ioctl SIOCGIFHWADDR" );
        close( rawssockfd);
        return -1;
    }

	printf("rawssockfd is:%2x\n",rawssockfd);
	return 0;
}

void print_buf(char buf[]){
               int f=0; for (f=0; f<6; f++)printf(":%.2x",(unsigned char)buf[f])&0xff;
               printf("  -->  ");
               for (f=6; f<12; f++)printf(":%.2x",(unsigned char)buf[f])&0xff; printf("\n");
               for (f=17; f<25; f++)printf("[%02d]:%.2x ",f,(unsigned char)buf[f])&0xff; printf("\n");
}

#ifdef WITH_SHMEM
int  get_shmem(){
    #define  SHMMIN 128
    #define  SHMEMKEY 12391
    int shID;
                printf("recbufs: %p try to get %x bytes - KEY=%d\n",recbufs,SHMMIN,shkey);
    shID = shmget(SHMEMKEY, SHMMIN, IPC_CREAT | 0666  );
                if(debug)printf("recbufs: %p \n",recbufs);
        if(debug) printf("shID: %d\n",shID);
    if (shID >= 0) {
        if(debug)printf("recbufs: %p\n",recbufs);
        recbufs = shmat(shID, NULL, 0);
        if(debug)printf("recbufs: %p\n",recbufs);
        printf("shID: %d\n",shID);
        if (recbufs<0) {
            perror("shmat");
        } else {
		if (debug) printf("recbufs->outval: %u \n",recbufs->outval[0]);
                if (debug) printf("recbufs->inval : %u \n",recbufs->inval[0]);
                recbufs->inval[0]=0xf8;
                recbufs->outval[0]=0xf8;
                if (debug) printf("recbufs->outval: %u \n",recbufs->outval[0]);
                if (debug) printf("recbufs->inval : %u \n",recbufs->inval[0]);
        return 0;
        }
    } else { /* shmget went wrong  */
        perror("shmget");
    }
return -1;
}
#endif

int snd_raw2pc(){
// this part is sending.
        bool do_send=false;
        if (lastgpioin[0]!=recbufs->validinval[0])do_send=true;
        if (lastgpioin[1]!=recbufs->validinval[1])do_send=true;
        if (lastgpioin[2]!=recbufs->validinval[2])do_send=true;
        if (lastgpioin[3]!=recbufs->validinval[3])do_send=true;
        if (lastgpioin[4]!=recbufs->validinval[4])do_send=true;
        if  ((testmode & testmode_sflood)>0) do_send=true;
//      do_send=true;   //force sending
        if (do_send) {
        if (debounce) 
        usleep(debounce);     // enprellen!
	if (debug) printf("Xlastout[0]:%u recbufs->validinval[0]:%u\n",lastout[0],recbufs->validinval[0]);
//              move_valid_to_buf();
                /* Index of the network device */
                socket_address.sll_ifindex = if_idx.ifr_ifindex;
                /* Address length*/
                socket_address.sll_halen = ETH_ALEN;
                /* Destination MAC */
                recbufs->ssh[0] = rmac[0];
                recbufs->ssh[1] = rmac[1];
                recbufs->ssh[2] = rmac[2];
                recbufs->ssh[3] = rmac[3];
                recbufs->ssh[4] = rmac[4];
                recbufs->ssh[5] = rmac[5];

          recbufs->sdh[0] = smac[0];
          recbufs->sdh[1] = smac[1];
          recbufs->sdh[2] = smac[2];
          recbufs->sdh[3] = smac[3];
          recbufs->sdh[4] = smac[4];
          recbufs->sdh[5] = smac[5];

	// raspi-version zaehlt _immer_ ihre sendepakete selbst !?
        recbufs->ssndrawcount=sndrawcount;

                /* Send packet */
                int sent=write(rawssockfd, recbufs->sdh, PKTLEN); /*tx_len*/
                if (sent<0) {
                        perror("SENDTO");
                        printf("send failed\n");
                        return -1;
                        }
                lastgpioin[0]=recbufs->validinval[0];
                lastgpioin[1]=recbufs->validinval[1];
                lastgpioin[2]=recbufs->validinval[2];
                lastgpioin[3]=recbufs->validinval[3];
                lastgpioin[4]=recbufs->validinval[4];
                sndrawcount=sndrawcount+1;
                return sent;
                }
        return 0;
// end of sending part
}



int snd_raw2raspi(){
// this part is sending.
        bool do_send=false;
        if (lastout[0]!=recbufs->validoutval[0])do_send=true;
        if (lastout[1]!=recbufs->validoutval[1])do_send=true;
        if (lastout[2]!=recbufs->validoutval[2])do_send=true;
        if (lastout[3]!=recbufs->validoutval[3])do_send=true;
        if (lastout[4]!=recbufs->validoutval[4])do_send=true;

        if  ((testmode & testmode_sflood)>0) do_send=true;

//      do_send=true;
        if (do_send) {
//              move_valid_to_buf();
                /* Index of the network device */
                socket_address.sll_ifindex = if_idx.ifr_ifindex;
                /* Address length*/
                socket_address.sll_halen = ETH_ALEN;
                /* Destination MAC */
                recbufs->ssh[0] = rmac[0];
                recbufs->ssh[1] = rmac[1];
                recbufs->ssh[2] = rmac[2];
                recbufs->ssh[3] = rmac[3];
                recbufs->ssh[4] = rmac[4];
                recbufs->ssh[5] = rmac[5];

          recbufs->sdh[0] = smac[0];
          recbufs->sdh[1] = smac[1];
          recbufs->sdh[2] = smac[2];
          recbufs->sdh[3] = smac[3];
          recbufs->sdh[4] = smac[4];
          recbufs->sdh[5] = smac[5];

//              micros=getMicrotime();
//                long diffmicros=micros-lastmicros;
//              if (debug)
//                      printf("lastmicos: %lu micros: %lu diff: %lu size: %lu\n", lastmicros, micros, diffmicros,sizeof(diffmicros));
//                lastmicros=micros;
//                memcpy(&sndbuf[40],&diffmicros,sizeof(diffmicros));
//              sndbuf[50]=sndcount;
                /* Send packet */


#ifdef WITH_RT_SHMEM			// wenn shmem-version, dann zaehle diepakete selbst 
        recbufs->ssndrawcount=sndrawcount;
#endif

	if (debug & deb_sraw ) {
	        printf("alastout[0]:%u recbufs->validoutval[0]:%u\n",lastout[0],recbufs->validoutval[0]);
	        printf("alastin[0]:%u recbufs->validinval[0]:%u\n",lastout[0],recbufs->validinval[0]);
	        printf("alastin[0]:%u recbufs->inval[0]:%u\n",lastout[0],recbufs->inval[0]);
	        printf("alastin[0]:%u recbufs->outval[0]:%u\n",lastout[0],recbufs->outval[0]);
		print_sheader(PKTLEN);
		}


                int sent=write(rawssockfd, recbufs->sdh, PKTLEN); /*tx_len*/
                if (sent<0) {
                        perror("SENDTO");
                        printf("send failed\n");
                        return -1;
                        }
                lastout[0]=recbufs->validoutval[0];
                lastout[1]=recbufs->validoutval[1];
                lastout[2]=recbufs->validoutval[2];
                lastout[3]=recbufs->validoutval[3];
                lastout[4]=recbufs->validoutval[4];
                sndrawcount=sndrawcount+1;
                return sent;
                }
        return 0;
// end of sending part
}



