/*
################################################
# linuxCNC-raspberry-driver (raspberry-side=
# compiling: gcc rasPIioEthRaw.c -lbcm2835 -lpthread -o rasPIioEthRaw
# usage:     sudo ./rasPIioEthRaw  -i eth0 -r 06:05:04:03:02:01 -s 01:02:03:04:05:06
# part of the linuxCNC-raspberry/arduino-project
# (c) by Ralf Burger 2019
# Licence GPL
# http://erste.de/ethraw/
################################################
*/
#include <time.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include <unistd.h>


#include <unistd.h>

#include <sys/socket.h>
#include <sys/ioctl.h>
#include <linux/if.h>
#include <linux/if_packet.h>
#include <linux/if_ether.h>
#include <arpa/inet.h>
#include <fcntl.h>

#include <stdio.h>
#include <termios.h>



#define SNDKEY  0x53 //"S"
#define READKEY 0x52 // "R"

void print_stamp();
#include <bcm2835.h>
#include "GPIO.h"



void *thread_func(void *data);
#include <pthread.h>
#include <limits.h>
#include <sys/mman.h>
#define  MY_STACK_SIZE 100


       #include <sys/ipc.h>
       #include <sys/shm.h>

void help(){
	printf("compile with:\n");
	printf("\t gcc rasPIioEthRaw.c  -o rasPIioEthRaw  -lpthread -lbcm2835\n");
	printf("\n");
	printf("\n");
	}


#define ISRASPI 1
#include "defs.h"
#include "commandline.c"
#include "func.c"
int sent;
int lost_packets=0;


int gpio_init(){
    if (!bcm2835_init())return 1;
	int f; int byte;
    // Sets the pin as input.
    bcm2835_gpio_fsel(PINzH  , BCM2835_GPIO_FSEL_INPT);
    bcm2835_gpio_fsel(PINaH  , BCM2835_GPIO_FSEL_INPT);
    bcm2835_gpio_fsel(PINyH  , BCM2835_GPIO_FSEL_INPT);
    bcm2835_gpio_fsel(PINxH  , BCM2835_GPIO_FSEL_INPT);
    bcm2835_gpio_fsel(PIN_P  , BCM2835_GPIO_FSEL_INPT);
    // Sets the Pull-up mode for the pin.
    bcm2835_gpio_set_pud(PINzH  , BCM2835_GPIO_PUD_UP);
    bcm2835_gpio_set_pud(PINaH  , BCM2835_GPIO_PUD_UP);
    bcm2835_gpio_set_pud(PINyH  , BCM2835_GPIO_PUD_UP);
    bcm2835_gpio_set_pud(PINxH  , BCM2835_GPIO_PUD_UP);
    bcm2835_gpio_set_pud(PIN_P  , BCM2835_GPIO_PUD_UP);

        for (byte=0; byte<4; byte++){
             for (f=0; f<=7; f++){ bcm2835_gpio_fsel(P_OUT_array[byte][f], BCM2835_GPIO_FSEL_OUTP); }
         }


 }

void gpio_getpin(int key,int bit){   // schreibt nach validinval
if  (bcm2835_gpio_lev(key)) {recbufs->validinval[0]= recbufs->validinval[0] | bit;} else {recbufs->validinval[0]= recbufs->validinval[0] & (255-bit);};
}



void gpio_get_pins(){ // schreibt nach validinval
	gpio_getpin(PINzH  ,MASKzH);
	gpio_getpin(PINaH  ,MASKaH);
	gpio_getpin(PINyH  ,MASKyH);
	gpio_getpin(PINxH  ,MASKxH);
	gpio_getpin(PIN_P  ,MASK_P);

}

void setGPIObit(int invert,int buf,int PIN,int bit){
        if (invert>0) buf= ~buf;
        if ((buf&bit)>0) {
                bcm2835_gpio_write(PIN, HIGH);
                if (DEBUG & DEB_MOTOR) printf("PIN_%2d HIGH  ",PIN);
                } else {
                bcm2835_gpio_write(PIN, LOW);
                if (DEBUG & DEB_MOTOR) printf("PIN_%2d LOW   ",PIN);
                }
}

static int tmpcount=0;
static int sndcount=0;
int  send_data(){
	gpio_get_pins();
	int pktSz=0;
	int do_send=(port_data_array->inval[0]!=lastGPIOin);
	if  ((testmode & testmode_sflood)>0) do_send=true; 

	if (do_send){
	         memcpy(&sndbuf[0], &smac[0], 6);
	         memcpy(&sndbuf[6], &rmac[0], 6);

                sndbuf[15]='i';   // 0x069  key  
                sndbuf[16]=0;     // second byte
                sndbuf[17]=port_data_array->inval[0];
                sndbuf[18]=port_data_array->inval[1];
                sndbuf[19]=port_data_array->inval[2];
                sndbuf[20]=port_data_array->inval[3];
                sndbuf[21]=port_data_array->inval[4];
                sndbuf[22]=0;     // second byt
               sndbuf[23]=sndcount;
              sndbuf[24]=sndcount;





		pktSz=20;
    		sndbuf[pktSz+6]=SNDKEY;
    		sndbuf[pktSz+7]=sent;
		if (debug>0){
	    		int f=0; for (f=0; f<pktSz; f++)printf("%2x ",sndbuf[f]); printf("\n");
			printf("send to socket:%2x",rawssockfd);
	        	print_buf(sndbuf);
		}
		int bytes = write(rawssockfd, sndbuf, pktSz+20);
		if (bytes<0) { perror("write"); }
		if ((debug&deb_sraw)>0)	printf("bytes sent:%2x\n",bytes);
		lastGPIOin=port_data_array->inval[0];
		sent=sent+1;
		sndcount=sndcount+1;
                tmpcount++;
                if (tmpcount>100000){print_stamp();printf(" 100k packets sent\n");tmpcount=0;}
	}
// END this part sends the input-bytes of the rasPI as raw packets to MAC-adre
}


int lower_all_quadstep_pins(){   // lowers all qaud-signal-STEP pins
	int f;int byte=0;
        for (byte=0; byte<4; byte++){
             for (f=0; f<=7; f++){
             if (P_QUADSTEP_array[byte][f][0]!=0xff)  // its a quad-signal 
                    {
			  printf("lower quadstep P_OUT_array[%2i][%2i]\n",byte,f);
  	                  bcm2835_gpio_write(P_OUT_array[byte][f], 0);   //lower the step-pin
                    }
              }
         }
}





static unsigned int lastEthInNr=0, pktInNr=0;
static bool firstEthIn=false;
static int step_type=15;

static unsigned char mvar=0;
static unsigned char lastmvar=0;
static unsigned char dir=0;

void signal_on_00(){   // sets a 1usec. peak-signal on pin 0
		int f;
		printf("test 0.0\n");
		bcm2835_gpio_write(0,0);
		bcm2835_gpio_write(0,1);
		bcm2835_gpio_write(0,0);
		bcm2835_gpio_write(P_OUT_array[0][0], 0); // just show a eak foer debugging
//		for (f=1; f<=1; f++){}	// time to hold STEP-pule high
		bcm2835_gpio_write(P_OUT_array[0][0], 1); 
//		for (f=1; f<=10; f++){}	// time to hold STEP-pule high
		bcm2835_gpio_write(P_OUT_array[0][0], 0); 
}

static double lasttime,lasttdiff;

void print_packettime(){
	time_t curtime;
        struct timeval tv;
        long  usecs;
        char time_buffer[30];
	double akttime;
        int s, bytes;
        char packet[1500];

//      bytes = read(s, packet,sizeof(packet));
        // get last packet receive time...
        ioctl(rawrsockfd, SIOCGSTAMP, &tv);
        curtime=tv.tv_sec;
        usecs=tv.tv_usec;
        strftime (time_buffer, 30, "%Y-%m-%d, %T",
        localtime(&curtime));
	akttime= tv.tv_sec + (1.0/1000000) * tv.tv_usec;

//DEBUG!
//	if ((akttime-lasttime)>0.000150)
//	        printf("1Zeit: %s.%06d  time:%1.6f\n", time_buffer, usecs,akttime-lasttime);

	lasttdiff=(akttime-lasttime);
	lasttime=akttime;

}




void do_portset(){
int f;int byte=0;
unsigned char qscounter=0;      //number of quad-signal
int dirpin;int dirbyte;qscounter=0;
unsigned char val;
bool doout=true; //false;      //disable any gpio-output (debug)
move_buf_to_valid();
if (testmode&testmode_porttest) {
		signal_on_00();
//		lastGPIOin++;     // force a loopback-packet
		} else 
		{
	        for (byte=0; byte<4; byte++){
                if (DEBUG & DEB_MOTOR)print_buf(recbuf);
                        for (f=0; f<=7; f++){
                                val=(recbufs->validoutval[byte]&(1<<f));
                                if (P_OUT_INV_array[byte][f])val=!(recbufs->validoutval[byte]&(1<<f));
                                        if (debug & deb_port)
                                        printf("set P_OUT_array[%02d][%02d] %02d to %02d  INV? %1d  %2d\n",
                                        byte,f,P_OUT_array[byte][f] ,
                                        (recbufs->validoutval[byte]&(1<<f)),(P_OUT_INV_array[byte][f]),val);

//					if (byte==0) if (f==0)printf("val: %d  phaseb: %d \n",val,((recbuf[byte+17]&2)!=2));
				 		if (P_QUADSTEP_array[byte][f][0]==0xff) 
							if  (P_QUADSTEP_REVLUT_array[byte][f][0]==0xff) 
								if (doout) bcm2835_gpio_write(P_OUT_array[byte][f], val); //direct output to GPIO
					if (P_QUADSTEP_array[byte][f][0]!=0xff)  // its a quad-signal 
						{
						val=0;						
					 	if (recbufs->validoutval[byte]&(1<<f)) val=1;	
						dirbyte=P_QUADSTEP_array[byte][f][0];
						dirpin=P_QUADSTEP_array[byte][f][1];
						if (debug & deb_quad)	printf("byte %3i bit %2i is quad. dirbyte is %2i dirpin is %3i, val is %2i\n",byte,f,dirbyte,dirpin,val);
						unsigned char phaseb=((recbufs->validoutval[byte] & (1<<dirpin))==0);
					 	qvar[qscounter]=val+phaseb*2;	
                				dir=1;
                				if (lastqvar[qscounter]!=qvar[qscounter]){
                        				if (lastqvar[qscounter]==0) if (qvar[qscounter]!=1)dir=0;
                        				if (lastqvar[qscounter]==1) if (qvar[qscounter]!=2)dir=0;
                        				if (lastqvar[qscounter]==2) if (qvar[qscounter]!=3)dir=0;
                        				if (lastqvar[qscounter]==3) if (qvar[qscounter]!=0)dir=0;


						if (debug & deb_quad)
							printf("dirbyte: %d, dirpin: %d   val: %d   phaseb: /%d   qvar: %d   qscounter: %d  dir: %d\n",
							dirbyte,dirpin,val,phaseb,qvar[0],qscounter,dir);
						 if (doout)bcm2835_gpio_write(P_OUT_array[dirbyte][dirpin], dir);   //set the DIR-pin
						 if (doout){
							bcm2835_gpio_write(P_OUT_array[byte][f], 1);             //raise the STEP-pin
							usleep (100);  //fixme!!!
							bcm2835_gpio_write(P_OUT_array[byte][f], 0);             //lower the STEP-pin
						}
						}
						lastqvar[qscounter]=qvar[qscounter];
						qscounter++;
						}
					
                                }
                        lastout[byte]=recbufs->validoutval[byte];
        }

			if (qscounter>0){
//				for (f=1; f<=50; f++){}	// time to hold STEP-pule high
//				lower_all_quadstep_pins();   //fixme!!!

			}


	}
}



long long waitcount;

static long long microdiff;
void check_packettime(){
	print_packettime();
	microdiff = *(long long*)&recbuf[40];

/*		printf("recbuf %2x %2x %2x %2x %2x %2x %2x %2x %2x %2x %2x microdiff: %llu  lost: %d\n",
				recbuf[40], 
				recbuf[41], 
				recbuf[42], 
				recbuf[43], 
				recbuf[44], 
				recbuf[45], 
				recbuf[46], 
				recbuf[47], 
				recbuf[48], 
				recbuf[49],
				recbuf[50],
				microdiff ,lost_packets);*/
//		tv.tv_usec=256*256*recbuf[50]+recbuf[48]+recbuf[49]*256;	
//		tv.tv_usec=256*recbuf[48]+recbuf[49];	
//		printf("mytime: %lu.%lu - pstamp: %lu.%lu\n",mytv.tv_sec,mytv.tv_usec,tv.tv_sec,tv.tv_usec);
		bool sendit=false;
		if (lastmicros==0) sendit=true;
		while (!sendit) {
			long long timegone=getMicrotime()-lastmicros;
		 	if (timegone >=microdiff) sendit=1;
		 	if (!sendit){
//				printf("WAIT!!!! micodiff:%lld > timegone: %lld\n",microdiff,timegone);
//				printf("micors-lastmicros:%lld\n",micros-lastmicros);
//				printf("micros:%lld pktnr: %d\n",micros,count);
				waitcount=waitcount+1;
			}
		}

//		if ((micros-lastmicros)<microdiff) {printf("WAIT!!!! lastmicros-micros: %llu,microdiff: %lu, micros: %llu \n",
//				(micros-lastmicros), microdiff, micros);}
}



int rec_data(){
// receiving part
        bool doit=false;

        int count=0;

        if (!rec_raw()) return 0;  // this is not ours
//      return 0;
        { // the packt ist now in recbufs->validoutval
        if (debug & deb_match)  print_header(numbytes);

//      if (debug>0)   print_buf(recbuf);
//      printf("recbuf[17]: %2x, ->outval[0]:%2x, inval[0]:%2x, recbuf[17+5]:%2x \n", recbuf[17],recbufs->outval[0],recbufs->inval[0],recbuf[17+5]);
        doit=lastin[0]!=recbufs->validoutval[0];
         if (lastin[1]!=recbufs->validoutval[1]) doit=true;
         if (lastin[2]!=recbufs->validoutval[2]) doit=true;
         if (lastin[3]!=recbufs->validoutval[3]) doit=true;
         if (lastin[4]!=recbufs->validoutval[4]) doit=true;
         if (doit){
                lastin[0]=recbufs->validoutval[0];
                lastin[1]=recbufs->validoutval[0];
                lastin[2]=recbufs->validoutval[2];
                lastin[3]=recbufs->validoutval[3];
                lastin[4]=recbufs->validoutval[4];
                pktInNr=recbufs->sndrawcount;       // this number calculated by  the _SENDER_
        if (firstEthIn) {firstEthIn=false;lastEthInNr=pktInNr-1;}
        if (debug&2048)
                 printf("lastEthInNr:%4x pktInNr:%4x pktInNr-1:%4x-1\n",lastEthInNr,pktInNr,((pktInNr-1)/*&255*/));


        if (lastEthInNr!=((pktInNr-1)/*&255*/)){printf("PACKET LOST!!!lastEthInNr:%4x pktInNr:%4x\n",lastEthInNr,pktInNr);}
        lastEthInNr=pktInNr;
        }
        count++;
	do_portset();		
        if (count>100000){
        print_stamp();


                printf(" 100k packtes received.\n");
                count=0;
                }
        }  // isForMe   
//        print_stamp();
        // end of receiving part

}

void srtask() { // send and recieve task
//        if ((testmode & 1)==0)    send_data();  //snd_raw();
        if ((testmode & 1)==0)    {gpio_get_pins();snd_raw2pc();/*print_header(50);*/}  //snd_raw();
        if ((testmode & 2)==0)    rec_data();
        if (testmode & 4){
                        if (testmode & 8 ) printf("testmode 8\n");
//                         bcm2835_gpio_write(PINaS, HIGH);
//                       bcm2835_gpio_write(PINaS, LOW);
                }
        
//      rec_udp();
}


void *thread_func(void *data){
	lastGPIOin=-1;
	printf("thread is running...\n");
	while (1==1){
		srtask();   //loop forwever
	}
	close(rawssockfd);
	close(rawrsockfd);
        return NULL;
}



void init_P_QUADSTEP_REVLUT_array(){
	int byte; int pin;
      for (byte=0; byte<4; byte++){
           for (pin=0; pin<=7; pin++){
		if (P_QUADSTEP_array[byte][pin][0]!=0xff){
			printf("P_QUADSTEP_array[%2i][%2i]:{%3i,%3i}\n",byte,pin,P_QUADSTEP_array[byte][pin][0],P_QUADSTEP_array[byte][pin][1]);
			printf("%d:%d: set P_QUADSTEP_REVLUT_array[%d][%d][0,1]:[%d,%d]\n",byte,pin,
				P_QUADSTEP_array[byte][pin][0],    P_QUADSTEP_array[byte][pin][1],
				byte,pin);
			 P_QUADSTEP_REVLUT_array[P_QUADSTEP_array[byte][pin][0]][P_QUADSTEP_array[byte][pin][1]][0]=byte;
			 P_QUADSTEP_REVLUT_array[P_QUADSTEP_array[byte][pin][0]][P_QUADSTEP_array[byte][pin][1]][1]=pin;
			
		}
	   }
	}
}

int main(int argc, char *argv[])
{

lastmicros=0;

        printf("rasPIioEthRaw (c) Ralf Burger 2019  Rev. 0.93 29.03.2019\n");
	printf(" - read/write GPIO-Ports\n");
        printf("as raw-eth-packets\n");

        getCLopt(argc, argv);

	printf("destination MAC: "MAC_STR"\n",
        smac[0], smac[1], smac[2], smac[3], smac[4], smac[5]);
	 memcpy(&s_dstMac[0], &smac[0], 6);

	printf("rec. for MAC: "MAC_STR"\n",
        rmac[0], rmac[1], rmac[2], rmac[3], rmac[4], rmac[5]);
	 memcpy(&r_srcMac[0], &rmac[0], 6);
	printf("dev:%s\n",dev_name);

	gpio_init();
//	init_rec_socket();
//	init_snd_socket();
init_raw_rec_socket(dev_name);
init_raw_snd_socket(dev_name);
//init_udp_sock();

//	init_thread();

	init_P_QUADSTEP_REVLUT_array();


// kbd-getch() just for testing/debugging
// ein tastendruck simuliert ein eigehendes datenpaket und setzt
// port_data_array->inval[0] entsprechend - die veraenderungen von port_data_array->inval[0] 
// werden im eigentlichen arbeitsthread verarbeitet
static char c='0';
unsigned int toggle=1;
int f; int mode=1;int byte=0;
usleep(100);

if (testmode==testmode_timebase) {
	 long long now;
	unsigned char test;
	int firsttime=0;
	int usecs=100;
	 while (1==1){
	 	now=getMicrotime();
		if (firsttime<10) {
	           	bcm2835_gpio_write(P_OUT_array[0][0], 0);
			while ((now+usecs)>getMicrotime()){}
		 	now=getMicrotime();
        	   	bcm2835_gpio_write(P_OUT_array[0][0], 1);
			while ((now+usecs)>getMicrotime()){}
		}
		if (test!=port_data_array->outval[0])	{
			test=port_data_array->outval[0];
			if (firsttime<5){printf ("mem changed:%02x - (%2x) \n",test,5-firsttime);}
			firsttime++;
			}
		if (firsttime>=10){
			while ((now+usecs)>getMicrotime()){}		
			bcm2835_gpio_write(P_OUT_array[0][0],port_data_array->outval[0]);
		}
	 }	
}

while (c!='x'){
//	usleep(100);
  srtask();	
  if (1==1){
	if (c == 'i') mode=0;
	if (c == 'o') mode=1;
	if (c == '+') {byte++; if (byte==4) byte=0; printf("IO-byte:%01d\n",byte);}
        for (f=1; f<=8; f++){
	   if(c == 48+f){  
		printf("(1<<f):=%2d\n",(1<<(f-1)));
		if (mode==0){
			printf(" toggle IN bit %01d of byte[%01d]\n",f,byte); 
			printf("%2x:",port_data_array->inval[byte]); 
			port_data_array->inval[byte] ^= (1<<(f-1)); 
			printf("->%2x\n",port_data_array->inval[byte]); 
			}
		if (mode==1){

			printf(" toggle OUT bit %01d of byte[%01d]  -  PIN: %2d\n",
				f,byte,P_OUT_array[byte][f-1]); 
			printf("%2x:",port_data_array->outval[byte]); 
			port_data_array->outval[byte]=port_data_array->outval[byte] ^= (1<<(f-1)); 
			printf("->%2x\n",port_data_array->outval[byte]);
			bcm2835_gpio_write(P_OUT_array[byte][f-1], port_data_array->outval[byte]);
			}				
		}
	     }
//while (1==1){  //just a test-loop for rasPI
//				for (f=1; f<=8; f++){mode=0;}
//                                        bcm2835_gpio_write(P_OUT_array[0][2], 0);
//				for (f=1; f<=8; f++){mode=0;}
//                                        bcm2835_gpio_write(P_OUT_array[0][2], 1);
//}
///	usleep(10000);
	c = getch();
	}
    }
printf("c=%2x Exit....\n",c);
}

